/* Libraries to treat IP data file ; Header Definition    11/12/1999  */
/*         for ANSI C                                     11/12/1999  */
/*                              v2.04                      4/19/2002  */

/* Edit this if size of types differs */
typedef short int raxHead_s;	/* 2 */
typedef long int raxHead_l;		/* 4 */
typedef float raxHead_f;		/* 4 */

struct ipHead {
	char		name[10];	/* Name of the Device */	/*   0 -   9 */
	char		vers[10];	/* Version Number */		/*  10 -  19 */
	char		crnm[20];	/* Crystal Name */			/*  20 -  39 */
	char		crsy[12];	/* Crystal System */		/*  40 -  51 */
	raxHead_f	alng;	/* a-axis length in A */		/*  52 -  55 */
	raxHead_f	blng;	/* b-axis length in A */		/*  56 -  59 */
	raxHead_f	clng;	/* c-axis length in A */		/*  60 -  63 */
	raxHead_f	alfa;	/* angle alpha */				/*  64 -  67 */
	raxHead_f	beta;	/* angle beta */				/*  68 -  71 */
	raxHead_f	gamm;	/* angle gamma */				/*  72 -  75 */
	char		spgr[12];	/* Space Group */			/*  76 -  87 */
	raxHead_f	mosc;	/* Mozaic Spread */				/*  88 -  91 */
	char		memo[80];	/* Memo */					/*  92 - 171 */
	char		res1[84];	/* --Reserved-- */			/* 172 - 255 */

	char		date[12];	/* Date of Measurement */	/* 256 - 267 */
	char		opnm[20];	/* Operator Name */			/* 268 - 287 */
	char		trgt[4];	/* X-ray Target */			/* 288 - 291 */
	raxHead_f	wlng;	/* Wave Length of the x-ray */	/* 292 - 295 */
	char		mcro[20];	/* Monochromator Material */	/* 296 - 315 */
	raxHead_f	m2ta;	/* Angle of the monochromator in 2-theta */	/* 316 - 319 */
	char		colm[20];	/* Collimator */			/* 320 - 339 */
	char		filt[4];	/* Kb filter */				/* 340 - 343 */
	raxHead_f	camr;	/* Camera length in mm */		/* 344 - 347 */
	raxHead_f	vltg;	/* X-ray tube voltage */		/* 348 - 351 */
	raxHead_f	crnt;	/* X-ray tube current */		/* 352 - 355 */
	char		focs[12];	/* X-ray focus */			/* 356 - 367 */
	char		optc[80];	/* X-ray optics */			/* 368 - 447 */
	raxHead_l	cyld;	/* Camera type */				/* 448 - 451 */
	raxHead_f	weis;	/* weisenberg oscillation */	/* 452 - 455 */
	char		res2[56];	/* --Reserved-- */			/* 456 - 511 */

	char		mnax[4];	/* Mount Axis */			/* 512 - 515 */
	char		bmax[4];	/* Beam Axis */				/* 516 - 519 */
	raxHead_f	phi0;	/* phi0 */						/* 520 - 523 */
	raxHead_f	phis;	/* phi start */					/* 524 - 527 */
	raxHead_f	phie;	/* phi end */					/* 528 - 531 */
	raxHead_l	oscn;	/* Frequency of Oscillation */	/* 532 - 535 */
	raxHead_f	fext;	/* Exposure Time in min. */		/* 536 - 539 */
	raxHead_f	drtx;	/* Direct Position X */			/* 540 - 543 */
	raxHead_f	drtz;	/* Direct position Y */			/* 544 - 547 */
	raxHead_f	omga;	/* omega in theta */			/* 548 - 551 */
	raxHead_f	fkai;	/* xai */						/* 552 - 555 */
	raxHead_f	thta;	/* 2-theta */					/* 556 - 559 */
	raxHead_f	mu;	/* mu */							/* 560 - 563 */
	char		res3[204];	/* --Reserved-- */			/* 564 - 767 */

	raxHead_l	xpxl;	/* Number of pixels in X direction */	/* 768 - 771 */
	raxHead_l	zpxl;	/* Number of pixels in Y direction */	/* 772 - 775 */
	raxHead_f	xsiz;	/* Pixel size in X direction in mm */	/* 776 - 779 */
	raxHead_f	zsiz;	/* Pixel size in Y direction in mm */	/* 780 - 783 */
	raxHead_l	rlng;	/* Record length in bytes */	/* 784 - 787 */
	raxHead_l	rnum;	/* Record number */				/* 788 - 791 */
	raxHead_l	ipst;	/* Line of start reading */		/* 792 - 795 */
	raxHead_l	ipnm;	/* Number of IP */				/* 796 - 799 */
	raxHead_f	rato;	/* Ratio of IP in High/Low */	/* 800 - 803 */
	raxHead_f	ft_1;	/* fading time 1 */				/* 804 - 807 */
	raxHead_f	ft_2;	/* fading time 2 */				/* 808 - 811 */
	char		host[10];	/* Type of Host Computer */	/* 812 - 821 */
	char		ip[10];	/* Type of IP */				/* 822 - 831 */
	raxHead_l	dr_x;	/* Data direction in horizontal */	/* 832 - 835 */
	raxHead_l	dr_z;	/* Data direction in vertical */	/* 836 - 839 */
	raxHead_l	drxz;	/* Data direction face/back */	/* 840 - 843 */
	char		res4[180];	/* --Reserved-- */			/* 844 -1023 */
};

struct ipHead2VER1 {
/* Exceeds 1024 bytes below */
	char		file[16];	/* FileName ?*/				/* 1024 - 1039 */
	raxHead_s	iext;	/* */							/* 1040 - 1041 */
	raxHead_s	reso;	/* WARNING!! */					/* 1042 - 1043 */
	raxHead_s	save;	/* If the compiler allocate memory with every 4 bytes,	*/	/* 1044 - 1045 */
/*	raxHead_l	dint;*/	/* these members may cause the gap of the size		*/
	raxHead_s	dint1;	/* between simple sum of members and total allocation.	*/	/* 1046 - 1047 */
	raxHead_s	dint2;	/* */							/* 1048 - 1049 */
	raxHead_s	byte;	/* */							/* 1050 - 1051 */
	char		res5[996];	/* --Reserved-- */			/* 1052 - 2047 */
};

struct ipHead2VER2 {
/* Exceeds 1024 bytes below */
	char		file[16];	/* FileName ?*/				/* 1024 - 1039 */
	char		cmnt[20];								/* 1040 - 1059 */
	char		smpl[20];								/* 1060 - 1079 */
	raxHead_l	iext;									/* 1080 - 1083 */
	raxHead_l	reso;									/* 1084 - 1087 */
	raxHead_l	save;									/* 1088 - 1091 */
	raxHead_l	dint;									/* 1092 - 1095 */
	raxHead_l	byte;	/* If data part is arranged with another endian, set to 1. */	/* 1096 - 1099 */
	raxHead_l	init;									/* 1100 - 1103 */
	raxHead_l	ipus;									/* 1104 - 1107 */
	raxHead_l	dexp;									/* 1108 - 1111 */
	raxHead_l	expn;									/* 1112 - 1115 */
	raxHead_l	posx[20];								/* 1116 - 1195 */
	raxHead_l	posy[20];								/* 1196 - 1275 */
	raxHead_l	xray;									/* 1276 - 1279 */
	char		res5[768];	/* --Reserved-- */			/* 1280 - 2047 */
};

#define SIZE_OF_IPHEADER sizeof(struct ipHead)
#define SIZE_OF_IPHEADER_EACH 1024
#define SIZE_OF_IPHEADER2VER1 sizeof(struct ipHead2VER1)
#define SIZE_OF_IPHEADER2VER1_EACH 1024
#define SIZE_OF_IPHEADER2VER2 sizeof(struct ipHead2VER2)
#define SIZE_OF_IPHEADER2VER2_EACH 1024
