/* Program to treat IP data file */
#define ProgName "iputils"
#define ProgInfo  "Show Version Number of iputils"
/*                                                        10/19/2000  */
/*         for ANSI C                                                 */

#define COPYRIGHT "(C) Tsurutani Naoki"
#define VERSION "v1.4.5_01_11/5/2010"

#include <stdio.h>
#include <stdlib.h>
#include "libm2.h"
#include "ipheader.h"
#include "libip.h"

int main()
{
	fprintf(stdout, " %s -- Some Programs to Treat R-AXIS Data Files.\n", ProgName);
	fprintf(stdout, "  Version %s // %s\n", VERSION, COPYRIGHT);
	fprintf(stdout, "  R-AXIS is Imaging Plate System by Rigaku Corp.\n");
	fprintf(stdout, "  This package is *not* provided by Rigaku Corp. !!\n");
	fprintf(stdout, "  See README and each programs' help for detail.\n");
	
/* Check the size of each type and CPU type */
	if (compilerCheck() && (compilerCheck() != 2)) {
		fprintf(stderr, " Important Warning : Fix problem and Recompile again.\n");
		fprintf(stderr, "  Size of data mismatch.\n");
		exit(EXIT_FAILURE);
	}
	if (compilerCheckIp()) {
		fprintf(stderr, " Important Warning : Fix problem and Recompile again.\n");
		fprintf(stderr, "  Size of IP Header mismatch.\n");
		exit(EXIT_FAILURE);
	}
	if (cpuCheck() != 0 && cpuCheck() != 1) {
		fprintf(stderr, " Important Warning : Fix problem and Recompile again.\n");
		fprintf(stderr, "  Unable to recognize this Platform.\n");
		exit(EXIT_FAILURE);
	}
	
	return 0;
}
