/* Libraries to treat Bitmap file                         12/28/1999  */
/*         for ANSI C                                                 */
/*                              v1.11d                      2/3/2006  */
/*                                               (C) Tsurutani Naoki  */

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <ctype.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include "libm2.h"
#include "bmpheader.h"
#include "libbmp.h"

#ifdef _OLDHP
char compilerCheckBmp()
#else
char compilerCheckBmp(void)
#endif
{
	if (SIZE_OF_BMPINFOHEADER != SIZE_OF_BMPINFOHEADER_EACH) return (1);
	if (SIZE_OF_BMPCOLOURHEADER != SIZE_OF_BMPCOLOURHEADER_EACH) return (1);
	if (SIZE_OF_BMPHEADER == SIZE_OF_BMPHEADER_EACH + 2) return (2);
	if (SIZE_OF_BMPHEADER != SIZE_OF_BMPHEADER_EACH) return (1);
	return (0);
}

#ifdef _OLDHP
char swapBmpHeader(bmpHeader)
	struct bmpHead *bmpHeader;
#else
char swapBmpHeader(struct bmpHead *bmpHeader)
#endif
{
	bmpHeader->bfSize = swapLong(bmpHeader->bfSize);
	bmpHeader->bfReserved1 = swapShort(bmpHeader->bfReserved1);
	bmpHeader->bfReserved2 = swapShort(bmpHeader->bfReserved2);
	bmpHeader->bfOffBits = swapLong(bmpHeader->bfOffBits);
	return (0);
}

#ifdef _OLDHP
char swapBmpInfoHeader(bmpInfoHeader)
	struct bmpInfoHead *bmpInfoHeader;
#else
char swapBmpInfoHeader(struct bmpInfoHead *bmpInfoHeader)
#endif
{
	bmpInfoHeader->biSize = swapLong(bmpInfoHeader->biSize);
	bmpInfoHeader->biWidth = swapLong(bmpInfoHeader->biWidth);
	bmpInfoHeader->biHeight = swapLong(bmpInfoHeader->biHeight);
	bmpInfoHeader->biPlanes = swapShort(bmpInfoHeader->biPlanes);
	bmpInfoHeader->biBitCount = swapShort(bmpInfoHeader->biBitCount);
	bmpInfoHeader->biCompression = swapLong(bmpInfoHeader->biCompression);
	bmpInfoHeader->biSizeImage = swapLong(bmpInfoHeader->biSizeImage);
	bmpInfoHeader->biXPelsPerMeter = swapLong(bmpInfoHeader->biXPelsPerMeter);
	bmpInfoHeader->biYPelsPerMeter = swapLong(bmpInfoHeader->biYPelsPerMeter);
	bmpInfoHeader->biClrUsed = swapLong(bmpInfoHeader->biClrUsed);
	bmpInfoHeader->biClrImportant = swapLong(bmpInfoHeader->biClrImportant);
	return (0);
}

#ifdef _OLDHP
char bmpMagicCheck(bmpHeader)
	struct bmpHead *bmpHeader;
#else
char bmpMagicCheck(struct bmpHead *bmpHeader)
#endif
{
	return (strncmp(bmpHeader->bfType, "BM", 2));
}
