/* Header File for Libraries to treat IP data file        11/12/1999  */
/*         for ANSI C                                     11/12/1999  */
/*                              v2.14                     12/25/1999  */
/*   Separated from libip.c                                 1/4/2000  */
/*                              v2.47                       3/6/2009  */

#define M_PI    3.14159265358979323846  /* pi   */
#define M_PI_2  1.57079632679489661923  /* pi/2 */
#define M_2PI   6.28318530717958647693  /* 2*pi  */
#define RAD_DEG 57.2957795130823208768  /* 180/pi */
#define DEG_RAD 0.01745329251994329576924  /* pi/180 */
#define FNAMELEN 1024	/* buffer size of filename */
#define MAXCHAR 1024
#ifdef _OLDHP
typedef double SUM_DOUBLE;
#	define SDBL0 0.0
#	define SDBL1 1.0
#else
typedef long double SUM_DOUBLE;
#	define SDBL0 0.0L
#	define SDBL1 1.0L
#endif

/* ==================================== */
/*
 * Edit This, to fit each platform
 *     INT16 < INT32 <= long
 */
/* IA32 */
typedef short int				INT16;
typedef long int				INT32;
typedef unsigned short int		UINT16;
typedef unsigned long int		UINT32;
/* AMD64 , LP64 */
#if 0
typedef short int				INT16;
typedef int						INT32;
typedef unsigned short int		UINT16;
typedef unsigned int			UINT32;
#endif
/* AMD64 , ILP64 */
#if 0
typedef short int				INT16;
typedef int32					INT32;	/* is it true ? */
typedef unsigned short int		UINT16;
typedef uint32					UINT32;	/* is it true ? */
#endif
/* ==================================== */

#ifdef _OLDHP
	double dist();
	float swapFloat();
	long int swapLong();
	unsigned long int swapULong();
	short int swapShort();
	unsigned short int swapUShort();
	long int dToLong();
	unsigned long int dToULong();
	short int dToShort();
	unsigned short int dToUShort();
	char cpuCheck();
	char compilerCheck();
	char isdigitEXT();
	char createFileEXT();
	char tmpNameEXT();
	char mkstempEXT();
	long int getValueFromStream();
	char base64en();
	char base64de();
	SUM_DOUBLE care_sum();
	double care_sumDbl();
	int compareSumDouble();
	int compareDouble();
	SUM_DOUBLE care_sum2();
	double care_sumDbl2();
#ifdef USE_QSORT
	void quickSort();
	void quick_sort();
	long int get_part();
#endif /* USE_QSORT */
	char solve2Deq();
	char solve3Deq();
	double bisect();
#else
	double dist(double x, double y);
	float swapFloat(float x);
	long int swapLong(long int x);
	unsigned long int swapULong(unsigned long int x);
	short int swapShort(short int x);
	unsigned short int swapUShort(unsigned short int x);
	long int dToLong(double x);
	unsigned long int dToULong(double x);
	short int dToShort(double x);
	unsigned short int dToUShort(double x);
	char cpuCheck(void);
	char compilerCheck(void);
	char isdigitEXT(const char *str);
	char createFileEXT(char *str, FILE **fp, char tflag);
	char tmpNameEXT(const char *str1, char *str2);
	char mkstempEXT(const char *str1, char *str2, FILE **fp, char tflag);
	long int getValueFromStream(FILE *fp, double *value, long int num, long int length, char flag);
	char base64en(const char *charPtr, char *resBuf, long int len);
	char base64de(const char *charPtr, char *resBuf, long int len, long int *newLen);
	SUM_DOUBLE care_sum(long int n, long double *data);
	double care_sumDbl(long int n, double *data);
	int compareSumDouble(const void *r1, const void *r2);
	int compareDouble(const void *r1, const void *r2);
	SUM_DOUBLE care_sum2(long int n, long double *data);
	double care_sumDbl2(long int n, double *data);
#ifdef USE_QSORT
	void quickSort(long int *data, long int n);
	void quick_sort(long int *data, long int r1, long int r2);
	long int get_part(long int *data, long int r1, long int r2);
#endif /* USE_QSORT */
	char solve2Deq(double *args, double *res);
	char solve3Deq(double *args, double *res);
	double bisect(double (*rfunc)(double x), double r0, double r1, double delta);
#endif

#ifndef EXIT_SUCCESS
#	define EXIT_SUCCESS 0
#endif

#ifndef EXIT_FAILURE
#	define EXIT_FAILURE 1
#endif

#ifndef O_BINARY
#	define O_BINARY 0x00
#endif
#ifndef O_TEXT
#	define O_TEXT 0x00
#endif
#ifndef _O_BINARY
#	define _O_BINARY 0x00
#endif
#ifndef _O_TEXT
#	define _O_TEXT 0x00
#endif

#define MAXEXT(x,y) (((x) > (y)) ? (x) : (y))

#define MINEXT(x,y) (((x) < (y)) ? (x) : (y))

#define XOREXT(x,y) ((((x) || (y)) && !((x) && (y))) ? (1) : (0))

#define signEXT(x) (((x) > 0) ? (1) : ((((x) < 0) ? (-1) : (0))))

#define radEXT(x) ((x) * DEG_RAD)

#define degEXT(x) ((x) * RAD_DEG)

#ifdef USE_RANDOM
#	define SRANDOM(x) srandom(x)
#	define RANDOM() random()
#	define RANDOM_MAX (0x7fffffff)
#else
#	define SRANDOM(x) srand(x)
#	define RANDOM() rand()
#	define RANDOM_MAX RAND_MAX
#endif
